/* capability-group.c generated by valac 0.56.7, the Vala compiler
 * generated from capability-group.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include "gnome-pomodoro.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

enum  {
	POMODORO_CAPABILITY_GROUP_0_PROPERTY,
	POMODORO_CAPABILITY_GROUP_NAME_PROPERTY,
	POMODORO_CAPABILITY_GROUP_NUM_PROPERTIES
};
static GParamSpec* pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL,
	POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL,
	POMODORO_CAPABILITY_GROUP_NUM_SIGNALS
};
static guint pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_NUM_SIGNALS] = {0};

struct _PomodoroCapabilityGroupPrivate {
	gchar* _name;
	GHashTable* capabilities;
};

static gint PomodoroCapabilityGroup_private_offset;
static gpointer pomodoro_capability_group_parent_class = NULL;

static GObject * pomodoro_capability_group_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void pomodoro_capability_group_finalize (GObject * obj);
static GType pomodoro_capability_group_get_type_once (void);
static void _vala_pomodoro_capability_group_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_pomodoro_capability_group_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);

static inline gpointer
pomodoro_capability_group_get_instance_private (PomodoroCapabilityGroup* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroCapabilityGroup_private_offset);
}

PomodoroCapabilityGroup*
pomodoro_capability_group_construct (GType object_type,
                                     const gchar* name)
{
	PomodoroCapabilityGroup * self = NULL;
#line 32 "../src/capability-group.vala"
	self = (PomodoroCapabilityGroup*) g_object_new (object_type, NULL);
#line 34 "../src/capability-group.vala"
	pomodoro_capability_group_set_name (self, name);
#line 32 "../src/capability-group.vala"
	return self;
#line 88 "capability-group.c"
}

PomodoroCapabilityGroup*
pomodoro_capability_group_new (const gchar* name)
{
#line 32 "../src/capability-group.vala"
	return pomodoro_capability_group_construct (POMODORO_TYPE_CAPABILITY_GROUP, name);
#line 96 "capability-group.c"
}

gboolean
pomodoro_capability_group_contains (PomodoroCapabilityGroup* self,
                                    const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gboolean result;
#line 42 "../src/capability-group.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/capability-group.vala"
	g_return_val_if_fail (capability_name != NULL, FALSE);
#line 44 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 44 "../src/capability-group.vala"
	result = g_hash_table_contains (_tmp0_, capability_name);
#line 44 "../src/capability-group.vala"
	return result;
#line 115 "capability-group.c"
}

PomodoroCapability*
pomodoro_capability_group_lookup (PomodoroCapabilityGroup* self,
                                  const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	PomodoroCapability* result;
#line 47 "../src/capability-group.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/capability-group.vala"
	g_return_val_if_fail (capability_name != NULL, NULL);
#line 49 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 49 "../src/capability-group.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 49 "../src/capability-group.vala"
	_tmp2_ = (PomodoroCapability*) _tmp1_;
#line 49 "../src/capability-group.vala"
	result = POMODORO_IS_CAPABILITY (_tmp2_) ? ((PomodoroCapability*) _tmp2_) : NULL;
#line 49 "../src/capability-group.vala"
	return result;
#line 140 "capability-group.c"
}

void
pomodoro_capability_group_foreach (PomodoroCapabilityGroup* self,
                                   GHFunc func,
                                   gpointer func_target)
{
	GHashTable* _tmp0_;
#line 52 "../src/capability-group.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 54 "../src/capability-group.vala"
	g_hash_table_foreach (_tmp0_, func, func_target);
#line 155 "capability-group.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/capability-group.vala"
	return self ? g_object_ref (self) : NULL;
#line 163 "capability-group.c"
}

gboolean
pomodoro_capability_group_add (PomodoroCapabilityGroup* self,
                               PomodoroCapability* capability)
{
	PomodoroCapability* existing_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	PomodoroCapability* _tmp10_;
	gboolean result;
#line 57 "../src/capability-group.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/capability-group.vala"
	g_return_val_if_fail (capability != NULL, FALSE);
#line 59 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 59 "../src/capability-group.vala"
	_tmp1_ = pomodoro_capability_get_name (capability);
#line 59 "../src/capability-group.vala"
	_tmp2_ = _tmp1_;
#line 59 "../src/capability-group.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
#line 59 "../src/capability-group.vala"
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
#line 59 "../src/capability-group.vala"
	existing_capability = _tmp4_;
#line 61 "../src/capability-group.vala"
	_tmp5_ = existing_capability;
#line 61 "../src/capability-group.vala"
	if (_tmp5_ != NULL) {
#line 62 "../src/capability-group.vala"
		result = FALSE;
#line 62 "../src/capability-group.vala"
		_g_object_unref0 (existing_capability);
#line 62 "../src/capability-group.vala"
		return result;
#line 209 "capability-group.c"
	}
#line 65 "../src/capability-group.vala"
	_tmp6_ = self->priv->capabilities;
#line 65 "../src/capability-group.vala"
	_tmp7_ = pomodoro_capability_get_name (capability);
#line 65 "../src/capability-group.vala"
	_tmp8_ = _tmp7_;
#line 65 "../src/capability-group.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 65 "../src/capability-group.vala"
	_tmp10_ = _g_object_ref0 (capability);
#line 65 "../src/capability-group.vala"
	g_hash_table_insert (_tmp6_, _tmp9_, _tmp10_);
#line 67 "../src/capability-group.vala"
	pomodoro_capability_set_group (capability, self);
#line 69 "../src/capability-group.vala"
	g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL], 0, capability);
#line 71 "../src/capability-group.vala"
	result = TRUE;
#line 71 "../src/capability-group.vala"
	_g_object_unref0 (existing_capability);
#line 71 "../src/capability-group.vala"
	return result;
#line 233 "capability-group.c"
}

void
pomodoro_capability_group_replace (PomodoroCapabilityGroup* self,
                                   PomodoroCapability* capability)
{
	PomodoroCapability* existing_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
	PomodoroCapability* _tmp6_;
#line 74 "../src/capability-group.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/capability-group.vala"
	g_return_if_fail (capability != NULL);
#line 76 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 76 "../src/capability-group.vala"
	_tmp1_ = pomodoro_capability_get_name (capability);
#line 76 "../src/capability-group.vala"
	_tmp2_ = _tmp1_;
#line 76 "../src/capability-group.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
#line 76 "../src/capability-group.vala"
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
#line 76 "../src/capability-group.vala"
	existing_capability = _tmp4_;
#line 78 "../src/capability-group.vala"
	_tmp5_ = existing_capability;
#line 78 "../src/capability-group.vala"
	if (_tmp5_ == capability) {
#line 79 "../src/capability-group.vala"
		_g_object_unref0 (existing_capability);
#line 79 "../src/capability-group.vala"
		return;
#line 272 "capability-group.c"
	}
#line 82 "../src/capability-group.vala"
	_tmp6_ = existing_capability;
#line 82 "../src/capability-group.vala"
	if (_tmp6_ == NULL) {
#line 278 "capability-group.c"
		GHashTable* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		PomodoroCapability* _tmp11_;
#line 83 "../src/capability-group.vala"
		_tmp7_ = self->priv->capabilities;
#line 83 "../src/capability-group.vala"
		_tmp8_ = pomodoro_capability_get_name (capability);
#line 83 "../src/capability-group.vala"
		_tmp9_ = _tmp8_;
#line 83 "../src/capability-group.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 83 "../src/capability-group.vala"
		_tmp11_ = _g_object_ref0 (capability);
#line 83 "../src/capability-group.vala"
		g_hash_table_insert (_tmp7_, _tmp10_, _tmp11_);
#line 296 "capability-group.c"
	} else {
		GHashTable* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		PomodoroCapability* _tmp16_;
		PomodoroCapability* _tmp17_;
#line 86 "../src/capability-group.vala"
		_tmp12_ = self->priv->capabilities;
#line 86 "../src/capability-group.vala"
		_tmp13_ = pomodoro_capability_get_name (capability);
#line 86 "../src/capability-group.vala"
		_tmp14_ = _tmp13_;
#line 86 "../src/capability-group.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 86 "../src/capability-group.vala"
		_tmp16_ = _g_object_ref0 (capability);
#line 86 "../src/capability-group.vala"
		g_hash_table_replace (_tmp12_, _tmp15_, _tmp16_);
#line 88 "../src/capability-group.vala"
		_tmp17_ = existing_capability;
#line 88 "../src/capability-group.vala"
		g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL], 0, _tmp17_);
#line 320 "capability-group.c"
	}
#line 91 "../src/capability-group.vala"
	pomodoro_capability_set_group (capability, self);
#line 93 "../src/capability-group.vala"
	g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL], 0, capability);
#line 74 "../src/capability-group.vala"
	_g_object_unref0 (existing_capability);
#line 328 "capability-group.c"
}

void
pomodoro_capability_group_remove (PomodoroCapabilityGroup* self,
                                  const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	PomodoroCapability* _tmp0_;
	PomodoroCapability* _tmp1_;
	PomodoroCapability* _tmp2_;
#line 96 "../src/capability-group.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/capability-group.vala"
	g_return_if_fail (capability_name != NULL);
#line 98 "../src/capability-group.vala"
	_tmp0_ = pomodoro_capability_group_lookup (self, capability_name);
#line 98 "../src/capability-group.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 98 "../src/capability-group.vala"
	capability = _tmp1_;
#line 100 "../src/capability-group.vala"
	_tmp2_ = capability;
#line 100 "../src/capability-group.vala"
	if (_tmp2_ != NULL) {
#line 353 "capability-group.c"
		GHashTable* _tmp3_;
		PomodoroCapability* _tmp4_;
#line 101 "../src/capability-group.vala"
		_tmp3_ = self->priv->capabilities;
#line 101 "../src/capability-group.vala"
		g_hash_table_remove (_tmp3_, capability_name);
#line 108 "../src/capability-group.vala"
		_tmp4_ = capability;
#line 108 "../src/capability-group.vala"
		g_signal_emit (self, pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL], 0, _tmp4_);
#line 364 "capability-group.c"
	}
#line 96 "../src/capability-group.vala"
	_g_object_unref0 (capability);
#line 368 "capability-group.c"
}

void
pomodoro_capability_group_remove_all (PomodoroCapabilityGroup* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 112 "../src/capability-group.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/capability-group.vala"
	_tmp0_ = self->priv->capabilities;
#line 114 "../src/capability-group.vala"
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
#line 382 "capability-group.c"
	{
		GList* capability_name_collection = NULL;
		GList* capability_name_it = NULL;
#line 114 "../src/capability-group.vala"
		capability_name_collection = _tmp1_;
#line 114 "../src/capability-group.vala"
		for (capability_name_it = capability_name_collection; capability_name_it != NULL; capability_name_it = capability_name_it->next) {
#line 390 "capability-group.c"
			const gchar* capability_name = NULL;
#line 114 "../src/capability-group.vala"
			capability_name = (const gchar*) capability_name_it->data;
#line 394 "capability-group.c"
			{
				const gchar* _tmp2_;
#line 115 "../src/capability-group.vala"
				_tmp2_ = capability_name;
#line 115 "../src/capability-group.vala"
				pomodoro_capability_group_remove (self, _tmp2_);
#line 401 "capability-group.c"
			}
		}
#line 114 "../src/capability-group.vala"
		(capability_name_collection == NULL) ? NULL : (capability_name_collection = (g_list_free (capability_name_collection), NULL));
#line 406 "capability-group.c"
	}
}

const gchar*
pomodoro_capability_group_get_name (PomodoroCapabilityGroup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/capability-group.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/capability-group.vala"
	_tmp0_ = self->priv->_name;
#line 28 "../src/capability-group.vala"
	result = _tmp0_;
#line 28 "../src/capability-group.vala"
	return result;
#line 423 "capability-group.c"
}

void
pomodoro_capability_group_set_name (PomodoroCapabilityGroup* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 28 "../src/capability-group.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/capability-group.vala"
	old_value = pomodoro_capability_group_get_name (self);
#line 28 "../src/capability-group.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 437 "capability-group.c"
		gchar* _tmp0_;
#line 28 "../src/capability-group.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/capability-group.vala"
		_g_free0 (self->priv->_name);
#line 28 "../src/capability-group.vala"
		self->priv->_name = _tmp0_;
#line 28 "../src/capability-group.vala"
		g_object_notify_by_pspec ((GObject *) self, pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NAME_PROPERTY]);
#line 447 "capability-group.c"
	}
}

static void
_g_free0_ (gpointer var)
{
#line 39 "../src/capability-group.vala"
	var = (g_free (var), NULL);
#line 456 "capability-group.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 39 "../src/capability-group.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 464 "capability-group.c"
}

static GObject *
pomodoro_capability_group_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroCapabilityGroup * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 37 "../src/capability-group.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_capability_group_parent_class);
#line 37 "../src/capability-group.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/capability-group.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
#line 39 "../src/capability-group.vala"
	_tmp0_ = g_str_hash;
#line 39 "../src/capability-group.vala"
	_tmp1_ = g_str_equal;
#line 39 "../src/capability-group.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 39 "../src/capability-group.vala"
	_g_hash_table_unref0 (self->priv->capabilities);
#line 39 "../src/capability-group.vala"
	self->priv->capabilities = _tmp2_;
#line 37 "../src/capability-group.vala"
	return obj;
#line 496 "capability-group.c"
}

static void
pomodoro_capability_group_class_init (PomodoroCapabilityGroupClass * klass,
                                      gpointer klass_data)
{
#line 26 "../src/capability-group.vala"
	pomodoro_capability_group_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/capability-group.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroCapabilityGroup_private_offset);
#line 26 "../src/capability-group.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_capability_group_get_property;
#line 26 "../src/capability-group.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_capability_group_set_property;
#line 26 "../src/capability-group.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_capability_group_constructor;
#line 26 "../src/capability-group.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_capability_group_finalize;
#line 26 "../src/capability-group.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_CAPABILITY_GROUP_NAME_PROPERTY, pomodoro_capability_group_properties[POMODORO_CAPABILITY_GROUP_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 26 "../src/capability-group.vala"
	pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_ADDED_SIGNAL] = g_signal_new ("capability-added", POMODORO_TYPE_CAPABILITY_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY);
#line 26 "../src/capability-group.vala"
	pomodoro_capability_group_signals[POMODORO_CAPABILITY_GROUP_CAPABILITY_REMOVED_SIGNAL] = g_signal_new ("capability-removed", POMODORO_TYPE_CAPABILITY_GROUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY);
#line 521 "capability-group.c"
}

static void
pomodoro_capability_group_instance_init (PomodoroCapabilityGroup * self,
                                         gpointer klass)
{
#line 26 "../src/capability-group.vala"
	self->priv = pomodoro_capability_group_get_instance_private (self);
#line 530 "capability-group.c"
}

static void
pomodoro_capability_group_finalize (GObject * obj)
{
	PomodoroCapabilityGroup * self;
#line 26 "../src/capability-group.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
#line 28 "../src/capability-group.vala"
	_g_free0 (self->priv->_name);
#line 30 "../src/capability-group.vala"
	_g_hash_table_unref0 (self->priv->capabilities);
#line 26 "../src/capability-group.vala"
	G_OBJECT_CLASS (pomodoro_capability_group_parent_class)->finalize (obj);
#line 545 "capability-group.c"
}

static GType
pomodoro_capability_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroCapabilityGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_capability_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroCapabilityGroup), 0, (GInstanceInitFunc) pomodoro_capability_group_instance_init, NULL };
	GType pomodoro_capability_group_type_id;
	pomodoro_capability_group_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroCapabilityGroup", &g_define_type_info, 0);
	PomodoroCapabilityGroup_private_offset = g_type_add_instance_private (pomodoro_capability_group_type_id, sizeof (PomodoroCapabilityGroupPrivate));
	return pomodoro_capability_group_type_id;
}

GType
pomodoro_capability_group_get_type (void)
{
	static volatile gsize pomodoro_capability_group_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_capability_group_type_id__once)) {
		GType pomodoro_capability_group_type_id;
		pomodoro_capability_group_type_id = pomodoro_capability_group_get_type_once ();
		g_once_init_leave (&pomodoro_capability_group_type_id__once, pomodoro_capability_group_type_id);
	}
	return pomodoro_capability_group_type_id__once;
}

static void
_vala_pomodoro_capability_group_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	PomodoroCapabilityGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
#line 26 "../src/capability-group.vala"
	switch (property_id) {
#line 26 "../src/capability-group.vala"
		case POMODORO_CAPABILITY_GROUP_NAME_PROPERTY:
#line 26 "../src/capability-group.vala"
		g_value_set_string (value, pomodoro_capability_group_get_name (self));
#line 26 "../src/capability-group.vala"
		break;
#line 586 "capability-group.c"
		default:
#line 26 "../src/capability-group.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/capability-group.vala"
		break;
#line 592 "capability-group.c"
	}
}

static void
_vala_pomodoro_capability_group_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	PomodoroCapabilityGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_CAPABILITY_GROUP, PomodoroCapabilityGroup);
#line 26 "../src/capability-group.vala"
	switch (property_id) {
#line 26 "../src/capability-group.vala"
		case POMODORO_CAPABILITY_GROUP_NAME_PROPERTY:
#line 26 "../src/capability-group.vala"
		pomodoro_capability_group_set_name (self, g_value_get_string (value));
#line 26 "../src/capability-group.vala"
		break;
#line 612 "capability-group.c"
		default:
#line 26 "../src/capability-group.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/capability-group.vala"
		break;
#line 618 "capability-group.c"
	}
}

