/* capability-manager.c generated by valac 0.56.7, the Vala compiler
 * generated from capability-manager.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include "gnome-pomodoro.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

enum  {
	POMODORO_CAPABILITY_MANAGER_0_PROPERTY,
	POMODORO_CAPABILITY_MANAGER_NUM_PROPERTIES
};
static GParamSpec* pomodoro_capability_manager_properties[POMODORO_CAPABILITY_MANAGER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
enum  {
	POMODORO_CAPABILITY_MANAGER_GROUP_ADDED_SIGNAL,
	POMODORO_CAPABILITY_MANAGER_GROUP_REMOVED_SIGNAL,
	POMODORO_CAPABILITY_MANAGER_CAPABILITY_ENABLED_SIGNAL,
	POMODORO_CAPABILITY_MANAGER_CAPABILITY_DISABLED_SIGNAL,
	POMODORO_CAPABILITY_MANAGER_NUM_SIGNALS
};
static guint pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_NUM_SIGNALS] = {0};

struct _PomodoroCapabilityManagerPrivate {
	GHashTable* capabilities;
	GHashTable* enabled_capabilities;
	GSList* groups;
};

struct _Block5Data {
	int _ref_count_;
	GHashTable* self;
	GFunc func;
	gpointer func_target;
};

static gint PomodoroCapabilityManager_private_offset;
static gpointer pomodoro_capability_manager_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void pomodoro_capability_manager_set_group_priority (PomodoroCapabilityGroup* group,
                                                     PomodoroPriority priority);
static gint pomodoro_capability_manager_group_priority_compare (PomodoroCapabilityGroup* a,
                                                         PomodoroCapabilityGroup* b);
static gint _pomodoro_capability_manager_group_priority_compare_gcompare_func (gconstpointer a,
                                                                        gconstpointer b);
static void pomodoro_capability_manager_on_group_capability_added (PomodoroCapabilityManager* self,
                                                            PomodoroCapabilityGroup* group,
                                                            PomodoroCapability* capability);
static void _pomodoro_capability_manager_on_group_capability_added_pomodoro_capability_group_capability_added (PomodoroCapabilityGroup* _sender,
                                                                                                        PomodoroCapability* capability,
                                                                                                        gpointer self);
static void pomodoro_capability_manager_on_group_capability_removed (PomodoroCapabilityManager* self,
                                                              PomodoroCapabilityGroup* group,
                                                              PomodoroCapability* capability);
static void _pomodoro_capability_manager_on_group_capability_removed_pomodoro_capability_group_capability_removed (PomodoroCapabilityGroup* _sender,
                                                                                                            PomodoroCapability* capability,
                                                                                                            gpointer self);
static void ___lambda14_ (PomodoroCapabilityManager* self,
                   const gchar* capability_name,
                   PomodoroCapability* capability);
static void pomodoro_capability_manager_add_capability_internal (PomodoroCapabilityManager* self,
                                                          PomodoroCapability* capability);
static void ____lambda14__gh_func (gconstpointer key,
                            gconstpointer value,
                            gpointer self);
static void ___lambda15_ (PomodoroCapabilityManager* self,
                   const gchar* capability_name,
                   PomodoroCapability* capability);
static void pomodoro_capability_manager_remove_capability_internal (PomodoroCapabilityManager* self,
                                                             PomodoroCapability* capability);
static void ____lambda15__gh_func (gconstpointer key,
                            gconstpointer value,
                            gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda0__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static void __lambda16_ (PomodoroCapabilityManager* self,
                  const gchar* capability_name);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
static PomodoroPriority pomodoro_capability_manager_get_group_priority (PomodoroCapabilityGroup* group);
static void pomodoro_capability_manager_real_dispose (GObject* base);
static GObject * pomodoro_capability_manager_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void pomodoro_capability_manager_finalize (GObject * obj);
static GType pomodoro_capability_manager_get_type_once (void);

static GType
pomodoro_priority_get_type_once (void)
{
	static const GEnumValue values[] = {{POMODORO_PRIORITY_LOW, "POMODORO_PRIORITY_LOW", "low"}, {POMODORO_PRIORITY_DEFAULT, "POMODORO_PRIORITY_DEFAULT", "default"}, {POMODORO_PRIORITY_HIGH, "POMODORO_PRIORITY_HIGH", "high"}, {0, NULL, NULL}};
	GType pomodoro_priority_type_id;
	pomodoro_priority_type_id = g_enum_register_static ("PomodoroPriority", values);
	return pomodoro_priority_type_id;
}

GType
pomodoro_priority_get_type (void)
{
	static volatile gsize pomodoro_priority_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_priority_type_id__once)) {
		GType pomodoro_priority_type_id;
		pomodoro_priority_type_id = pomodoro_priority_get_type_once ();
		g_once_init_leave (&pomodoro_priority_type_id__once, pomodoro_priority_type_id);
	}
	return pomodoro_priority_type_id__once;
}

static inline gpointer
pomodoro_capability_manager_get_instance_private (PomodoroCapabilityManager* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroCapabilityManager_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../src/capability-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 150 "capability-manager.c"
}

static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 37 "../src/capability-manager.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 158 "capability-manager.c"
}

PomodoroCapability*
pomodoro_capability_manager_get_preferred_capability (PomodoroCapabilityManager* self,
                                                      const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* result;
#line 51 "../src/capability-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/capability-manager.vala"
	g_return_val_if_fail (capability_name != NULL, NULL);
#line 53 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 53 "../src/capability-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 53 "../src/capability-manager.vala"
	result = (PomodoroCapability*) _tmp1_;
#line 53 "../src/capability-manager.vala"
	return result;
#line 180 "capability-manager.c"
}

gboolean
pomodoro_capability_manager_has_capability (PomodoroCapabilityManager* self,
                                            const gchar* capability_name)
{
	GHashTable* _tmp0_;
	gboolean result;
#line 56 "../src/capability-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/capability-manager.vala"
	g_return_val_if_fail (capability_name != NULL, FALSE);
#line 58 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 58 "../src/capability-manager.vala"
	result = g_hash_table_contains (_tmp0_, capability_name);
#line 58 "../src/capability-manager.vala"
	return result;
#line 199 "capability-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/capability-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 207 "capability-manager.c"
}

gboolean
pomodoro_capability_manager_has_enabled (PomodoroCapabilityManager* self,
                                         const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	gboolean _tmp3_ = FALSE;
	PomodoroCapability* _tmp4_;
	gboolean result;
#line 61 "../src/capability-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/capability-manager.vala"
	g_return_val_if_fail (capability_name != NULL, FALSE);
#line 63 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 63 "../src/capability-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 63 "../src/capability-manager.vala"
	_tmp2_ = _g_object_ref0 ((PomodoroCapability*) _tmp1_);
#line 63 "../src/capability-manager.vala"
	capability = _tmp2_;
#line 65 "../src/capability-manager.vala"
	_tmp4_ = capability;
#line 65 "../src/capability-manager.vala"
	if (_tmp4_ != NULL) {
#line 237 "capability-manager.c"
		PomodoroCapability* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 65 "../src/capability-manager.vala"
		_tmp5_ = capability;
#line 65 "../src/capability-manager.vala"
		_tmp6_ = pomodoro_capability_get_enabled (_tmp5_);
#line 65 "../src/capability-manager.vala"
		_tmp7_ = _tmp6_;
#line 65 "../src/capability-manager.vala"
		_tmp3_ = _tmp7_;
#line 249 "capability-manager.c"
	} else {
#line 65 "../src/capability-manager.vala"
		_tmp3_ = FALSE;
#line 253 "capability-manager.c"
	}
#line 65 "../src/capability-manager.vala"
	result = _tmp3_;
#line 65 "../src/capability-manager.vala"
	_g_object_unref0 (capability);
#line 65 "../src/capability-manager.vala"
	return result;
#line 261 "capability-manager.c"
}

gboolean
pomodoro_capability_manager_has_group (PomodoroCapabilityManager* self,
                                       PomodoroCapabilityGroup* group)
{
	GSList* _tmp0_;
	gboolean result;
#line 68 "../src/capability-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../src/capability-manager.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 70 "../src/capability-manager.vala"
	_tmp0_ = self->priv->groups;
#line 70 "../src/capability-manager.vala"
	result = g_slist_index (_tmp0_, group) >= 0;
#line 70 "../src/capability-manager.vala"
	return result;
#line 280 "capability-manager.c"
}

static gint
_pomodoro_capability_manager_group_priority_compare_gcompare_func (gconstpointer a,
                                                                   gconstpointer b)
{
	gint result;
	result = pomodoro_capability_manager_group_priority_compare ((PomodoroCapabilityGroup*) a, (PomodoroCapabilityGroup*) b);
#line 81 "../src/capability-manager.vala"
	return result;
#line 291 "capability-manager.c"
}

static void
_pomodoro_capability_manager_on_group_capability_added_pomodoro_capability_group_capability_added (PomodoroCapabilityGroup* _sender,
                                                                                                   PomodoroCapability* capability,
                                                                                                   gpointer self)
{
#line 83 "../src/capability-manager.vala"
	pomodoro_capability_manager_on_group_capability_added ((PomodoroCapabilityManager*) self, _sender, capability);
#line 301 "capability-manager.c"
}

static void
_pomodoro_capability_manager_on_group_capability_removed_pomodoro_capability_group_capability_removed (PomodoroCapabilityGroup* _sender,
                                                                                                       PomodoroCapability* capability,
                                                                                                       gpointer self)
{
#line 84 "../src/capability-manager.vala"
	pomodoro_capability_manager_on_group_capability_removed ((PomodoroCapabilityManager*) self, _sender, capability);
#line 311 "capability-manager.c"
}

static void
___lambda14_ (PomodoroCapabilityManager* self,
              const gchar* capability_name,
              PomodoroCapability* capability)
{
#line 86 "../src/capability-manager.vala"
	g_return_if_fail (capability_name != NULL);
#line 86 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 87 "../src/capability-manager.vala"
	pomodoro_capability_manager_add_capability_internal (self, capability);
#line 325 "capability-manager.c"
}

static void
____lambda14__gh_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
#line 86 "../src/capability-manager.vala"
	___lambda14_ ((PomodoroCapabilityManager*) self, (const gchar*) key, (PomodoroCapability*) value);
#line 335 "capability-manager.c"
}

void
pomodoro_capability_manager_add_group (PomodoroCapabilityManager* self,
                                       PomodoroCapabilityGroup* group,
                                       PomodoroPriority priority)
{
	GSList* group_link = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
#line 73 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/capability-manager.vala"
	g_return_if_fail (group != NULL);
#line 76 "../src/capability-manager.vala"
	_tmp0_ = self->priv->groups;
#line 76 "../src/capability-manager.vala"
	_tmp1_ = g_slist_find (_tmp0_, group);
#line 76 "../src/capability-manager.vala"
	group_link = _tmp1_;
#line 78 "../src/capability-manager.vala"
	_tmp2_ = group_link;
#line 78 "../src/capability-manager.vala"
	if (_tmp2_ == NULL) {
#line 361 "capability-manager.c"
		PomodoroCapabilityGroup* _tmp3_;
#line 79 "../src/capability-manager.vala"
		pomodoro_capability_manager_set_group_priority (group, priority);
#line 81 "../src/capability-manager.vala"
		_tmp3_ = _g_object_ref0 (group);
#line 81 "../src/capability-manager.vala"
		self->priv->groups = g_slist_insert_sorted (self->priv->groups, _tmp3_, _pomodoro_capability_manager_group_priority_compare_gcompare_func);
#line 83 "../src/capability-manager.vala"
		g_signal_connect_object (group, "capability-added", (GCallback) _pomodoro_capability_manager_on_group_capability_added_pomodoro_capability_group_capability_added, self, 0);
#line 84 "../src/capability-manager.vala"
		g_signal_connect_object (group, "capability-removed", (GCallback) _pomodoro_capability_manager_on_group_capability_removed_pomodoro_capability_group_capability_removed, self, 0);
#line 86 "../src/capability-manager.vala"
		pomodoro_capability_group_foreach (group, ____lambda14__gh_func, self);
#line 90 "../src/capability-manager.vala"
		g_signal_emit (self, pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_GROUP_ADDED_SIGNAL], 0, group);
#line 377 "capability-manager.c"
	} else {
	}
}

static void
___lambda15_ (PomodoroCapabilityManager* self,
              const gchar* capability_name,
              PomodoroCapability* capability)
{
#line 108 "../src/capability-manager.vala"
	g_return_if_fail (capability_name != NULL);
#line 108 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 109 "../src/capability-manager.vala"
	pomodoro_capability_manager_remove_capability_internal (self, capability);
#line 393 "capability-manager.c"
}

static void
____lambda15__gh_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
#line 108 "../src/capability-manager.vala"
	___lambda15_ ((PomodoroCapabilityManager*) self, (const gchar*) key, (PomodoroCapability*) value);
#line 403 "capability-manager.c"
}

void
pomodoro_capability_manager_remove_group (PomodoroCapabilityManager* self,
                                          PomodoroCapabilityGroup* group)
{
	GSList* group_link = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
#line 97 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/capability-manager.vala"
	g_return_if_fail (group != NULL);
#line 99 "../src/capability-manager.vala"
	_tmp0_ = self->priv->groups;
#line 99 "../src/capability-manager.vala"
	_tmp1_ = g_slist_find (_tmp0_, group);
#line 99 "../src/capability-manager.vala"
	group_link = _tmp1_;
#line 101 "../src/capability-manager.vala"
	_tmp2_ = group_link;
#line 101 "../src/capability-manager.vala"
	if (_tmp2_ != NULL) {
#line 428 "capability-manager.c"
		GSList* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
#line 103 "../src/capability-manager.vala"
		_tmp3_ = group_link;
#line 103 "../src/capability-manager.vala"
		self->priv->groups = g_slist_remove_link (self->priv->groups, _tmp3_);
#line 105 "../src/capability-manager.vala"
		g_signal_parse_name ("capability-added", POMODORO_TYPE_CAPABILITY_GROUP, &_tmp4_, NULL, FALSE);
#line 105 "../src/capability-manager.vala"
		g_signal_handlers_disconnect_matched (group, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _pomodoro_capability_manager_on_group_capability_added_pomodoro_capability_group_capability_added, self);
#line 106 "../src/capability-manager.vala"
		g_signal_parse_name ("capability-removed", POMODORO_TYPE_CAPABILITY_GROUP, &_tmp5_, NULL, FALSE);
#line 106 "../src/capability-manager.vala"
		g_signal_handlers_disconnect_matched (group, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _pomodoro_capability_manager_on_group_capability_removed_pomodoro_capability_group_capability_removed, self);
#line 108 "../src/capability-manager.vala"
		pomodoro_capability_group_foreach (group, ____lambda15__gh_func, self);
#line 112 "../src/capability-manager.vala"
		g_signal_emit (self, pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_GROUP_REMOVED_SIGNAL], 0, group);
#line 448 "capability-manager.c"
	}
}

void
pomodoro_capability_manager_enable (PomodoroCapabilityManager* self,
                                    const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	PomodoroCapability* _tmp6_;
#line 116 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/capability-manager.vala"
	g_return_if_fail (capability_name != NULL);
#line 118 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 118 "../src/capability-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 118 "../src/capability-manager.vala"
	_tmp2_ = _g_object_ref0 ((PomodoroCapability*) _tmp1_);
#line 118 "../src/capability-manager.vala"
	capability = _tmp2_;
#line 120 "../src/capability-manager.vala"
	_tmp3_ = self->priv->enabled_capabilities;
#line 120 "../src/capability-manager.vala"
	_tmp4_ = g_strdup (capability_name);
#line 120 "../src/capability-manager.vala"
	g_hash_table_add (_tmp3_, _tmp4_);
#line 122 "../src/capability-manager.vala"
	_tmp6_ = capability;
#line 122 "../src/capability-manager.vala"
	if (_tmp6_ != NULL) {
#line 486 "capability-manager.c"
		PomodoroCapability* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 122 "../src/capability-manager.vala"
		_tmp7_ = capability;
#line 122 "../src/capability-manager.vala"
		_tmp8_ = pomodoro_capability_get_enabled (_tmp7_);
#line 122 "../src/capability-manager.vala"
		_tmp9_ = _tmp8_;
#line 122 "../src/capability-manager.vala"
		_tmp5_ = !_tmp9_;
#line 498 "capability-manager.c"
	} else {
#line 122 "../src/capability-manager.vala"
		_tmp5_ = FALSE;
#line 502 "capability-manager.c"
	}
#line 122 "../src/capability-manager.vala"
	if (_tmp5_) {
#line 506 "capability-manager.c"
		PomodoroCapability* _tmp10_;
#line 123 "../src/capability-manager.vala"
		_tmp10_ = capability;
#line 123 "../src/capability-manager.vala"
		g_signal_emit_by_name (_tmp10_, "enable");
#line 512 "capability-manager.c"
	}
#line 116 "../src/capability-manager.vala"
	_g_object_unref0 (capability);
#line 516 "capability-manager.c"
}

void
pomodoro_capability_manager_disable (PomodoroCapabilityManager* self,
                                     const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	GHashTable* _tmp3_;
	gboolean _tmp4_ = FALSE;
	PomodoroCapability* _tmp5_;
#line 127 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/capability-manager.vala"
	g_return_if_fail (capability_name != NULL);
#line 129 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 129 "../src/capability-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 129 "../src/capability-manager.vala"
	_tmp2_ = _g_object_ref0 ((PomodoroCapability*) _tmp1_);
#line 129 "../src/capability-manager.vala"
	capability = _tmp2_;
#line 131 "../src/capability-manager.vala"
	_tmp3_ = self->priv->enabled_capabilities;
#line 131 "../src/capability-manager.vala"
	g_hash_table_remove (_tmp3_, capability_name);
#line 133 "../src/capability-manager.vala"
	_tmp5_ = capability;
#line 133 "../src/capability-manager.vala"
	if (_tmp5_ != NULL) {
#line 550 "capability-manager.c"
		PomodoroCapability* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 133 "../src/capability-manager.vala"
		_tmp6_ = capability;
#line 133 "../src/capability-manager.vala"
		_tmp7_ = pomodoro_capability_get_enabled (_tmp6_);
#line 133 "../src/capability-manager.vala"
		_tmp8_ = _tmp7_;
#line 133 "../src/capability-manager.vala"
		_tmp4_ = _tmp8_;
#line 562 "capability-manager.c"
	} else {
#line 133 "../src/capability-manager.vala"
		_tmp4_ = FALSE;
#line 566 "capability-manager.c"
	}
#line 133 "../src/capability-manager.vala"
	if (_tmp4_) {
#line 570 "capability-manager.c"
		PomodoroCapability* _tmp9_;
#line 134 "../src/capability-manager.vala"
		_tmp9_ = capability;
#line 134 "../src/capability-manager.vala"
		g_signal_emit_by_name (_tmp9_, "disable");
#line 576 "capability-manager.c"
	}
#line 127 "../src/capability-manager.vala"
	_g_object_unref0 (capability);
#line 580 "capability-manager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 5585 "glib-2.0.vapi"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 5585 "glib-2.0.vapi"
	return _data5_;
#line 590 "capability-manager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 5585 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 600 "capability-manager.c"
		GHashTable* self;
#line 5585 "glib-2.0.vapi"
		self = _data5_->self;
#line 5585 "glib-2.0.vapi"
		_g_hash_table_unref0 (self);
#line 5585 "glib-2.0.vapi"
		g_slice_free (Block5Data, _data5_);
#line 608 "capability-manager.c"
	}
}

static void
__lambda0_ (Block5Data* _data5_,
            gconstpointer k,
            gconstpointer v)
{
	GHashTable* self;
#line 5586 "glib-2.0.vapi"
	self = _data5_->self;
#line 5586 "glib-2.0.vapi"
	_data5_->func (v, _data5_->func_target);
#line 622 "capability-manager.c"
}

static void
___lambda0__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
#line 5586 "glib-2.0.vapi"
	__lambda0_ (self, key, value);
#line 632 "capability-manager.c"
}

static void
_vala_g_hash_set_foreach (GHashTable* self,
                          GFunc func,
                          gpointer func_target)
{
	Block5Data* _data5_;
#line 5585 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5585 "glib-2.0.vapi"
	_data5_ = g_slice_new0 (Block5Data);
#line 5585 "glib-2.0.vapi"
	_data5_->_ref_count_ = 1;
#line 5585 "glib-2.0.vapi"
	_data5_->self = g_hash_table_ref (self);
#line 5585 "glib-2.0.vapi"
	_data5_->func = func;
#line 5585 "glib-2.0.vapi"
	_data5_->func_target = func_target;
#line 5586 "glib-2.0.vapi"
	g_hash_table_foreach ((GHashTable*) self, ___lambda0__gh_func, _data5_);
#line 5585 "glib-2.0.vapi"
	block5_data_unref (_data5_);
#line 5585 "glib-2.0.vapi"
	_data5_ = NULL;
#line 659 "capability-manager.c"
}

static void
__lambda16_ (PomodoroCapabilityManager* self,
             const gchar* capability_name)
{
	PomodoroCapability* capability = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	PomodoroCapability* _tmp2_;
	gboolean _tmp3_ = FALSE;
	PomodoroCapability* _tmp4_;
#line 140 "../src/capability-manager.vala"
	g_return_if_fail (capability_name != NULL);
#line 141 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 141 "../src/capability-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, capability_name);
#line 141 "../src/capability-manager.vala"
	_tmp2_ = _g_object_ref0 ((PomodoroCapability*) _tmp1_);
#line 141 "../src/capability-manager.vala"
	capability = _tmp2_;
#line 143 "../src/capability-manager.vala"
	_tmp4_ = capability;
#line 143 "../src/capability-manager.vala"
	if (_tmp4_ != NULL) {
#line 686 "capability-manager.c"
		PomodoroCapability* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 143 "../src/capability-manager.vala"
		_tmp5_ = capability;
#line 143 "../src/capability-manager.vala"
		_tmp6_ = pomodoro_capability_get_enabled (_tmp5_);
#line 143 "../src/capability-manager.vala"
		_tmp7_ = _tmp6_;
#line 143 "../src/capability-manager.vala"
		_tmp3_ = _tmp7_;
#line 698 "capability-manager.c"
	} else {
#line 143 "../src/capability-manager.vala"
		_tmp3_ = FALSE;
#line 702 "capability-manager.c"
	}
#line 143 "../src/capability-manager.vala"
	if (_tmp3_) {
#line 706 "capability-manager.c"
		PomodoroCapability* _tmp8_;
#line 144 "../src/capability-manager.vala"
		_tmp8_ = capability;
#line 144 "../src/capability-manager.vala"
		g_signal_emit_by_name (_tmp8_, "disable");
#line 712 "capability-manager.c"
	}
#line 140 "../src/capability-manager.vala"
	_g_object_unref0 (capability);
#line 716 "capability-manager.c"
}

static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
#line 140 "../src/capability-manager.vala"
	__lambda16_ ((PomodoroCapabilityManager*) self, (const gchar*) data);
#line 725 "capability-manager.c"
}

void
pomodoro_capability_manager_disable_all (PomodoroCapabilityManager* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
#line 138 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/capability-manager.vala"
	_tmp0_ = self->priv->enabled_capabilities;
#line 140 "../src/capability-manager.vala"
	_vala_g_hash_set_foreach (_tmp0_, ___lambda16__gfunc, self);
#line 148 "../src/capability-manager.vala"
	_tmp1_ = self->priv->enabled_capabilities;
#line 148 "../src/capability-manager.vala"
	g_hash_table_remove_all (_tmp1_);
#line 743 "capability-manager.c"
}

static PomodoroPriority
pomodoro_capability_manager_get_group_priority (PomodoroCapabilityGroup* group)
{
	gconstpointer _tmp0_;
	PomodoroPriority result;
#line 151 "../src/capability-manager.vala"
	g_return_val_if_fail (group != NULL, 0);
#line 153 "../src/capability-manager.vala"
	_tmp0_ = g_object_get_data ((GObject*) group, "priority");
#line 153 "../src/capability-manager.vala"
	result = (PomodoroPriority) ((gintptr) _tmp0_);
#line 153 "../src/capability-manager.vala"
	return result;
#line 759 "capability-manager.c"
}

static void
pomodoro_capability_manager_set_group_priority (PomodoroCapabilityGroup* group,
                                                PomodoroPriority priority)
{
#line 156 "../src/capability-manager.vala"
	g_return_if_fail (group != NULL);
#line 159 "../src/capability-manager.vala"
	g_object_set_data_full ((GObject*) group, "priority", (gpointer) ((gintptr) priority), NULL);
#line 770 "capability-manager.c"
}

static gint
pomodoro_capability_manager_group_priority_compare (PomodoroCapabilityGroup* a,
                                                    PomodoroCapabilityGroup* b)
{
	PomodoroPriority a_priority = 0;
	PomodoroPriority b_priority = 0;
	gint result;
#line 163 "../src/capability-manager.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 163 "../src/capability-manager.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 166 "../src/capability-manager.vala"
	a_priority = pomodoro_capability_manager_get_group_priority (a);
#line 167 "../src/capability-manager.vala"
	b_priority = pomodoro_capability_manager_get_group_priority (b);
#line 169 "../src/capability-manager.vala"
	if (a_priority > b_priority) {
#line 170 "../src/capability-manager.vala"
		result = -1;
#line 170 "../src/capability-manager.vala"
		return result;
#line 794 "capability-manager.c"
	}
#line 173 "../src/capability-manager.vala"
	if (a_priority < b_priority) {
#line 174 "../src/capability-manager.vala"
		result = 1;
#line 174 "../src/capability-manager.vala"
		return result;
#line 802 "capability-manager.c"
	}
#line 177 "../src/capability-manager.vala"
	result = 0;
#line 177 "../src/capability-manager.vala"
	return result;
#line 808 "capability-manager.c"
}

static void
pomodoro_capability_manager_add_capability_internal (PomodoroCapabilityManager* self,
                                                     PomodoroCapability* capability)
{
	PomodoroCapability* preferred_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
	GHashTable* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
#line 180 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 182 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 182 "../src/capability-manager.vala"
	_tmp1_ = pomodoro_capability_get_name (capability);
#line 182 "../src/capability-manager.vala"
	_tmp2_ = _tmp1_;
#line 182 "../src/capability-manager.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
#line 182 "../src/capability-manager.vala"
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
#line 182 "../src/capability-manager.vala"
	preferred_capability = _tmp4_;
#line 184 "../src/capability-manager.vala"
	_tmp5_ = preferred_capability;
#line 184 "../src/capability-manager.vala"
	if (_tmp5_ != NULL) {
#line 845 "capability-manager.c"
		PomodoroCapability* _tmp6_;
		PomodoroCapability* _tmp7_;
		PomodoroCapabilityGroup* _tmp8_;
		PomodoroCapabilityGroup* _tmp9_;
		PomodoroCapabilityGroup* _tmp10_;
		PomodoroCapabilityGroup* _tmp11_;
#line 185 "../src/capability-manager.vala"
		_tmp6_ = preferred_capability;
#line 185 "../src/capability-manager.vala"
		g_signal_emit_by_name (_tmp6_, "disable");
#line 187 "../src/capability-manager.vala"
		_tmp7_ = preferred_capability;
#line 187 "../src/capability-manager.vala"
		_tmp8_ = pomodoro_capability_get_group (_tmp7_);
#line 187 "../src/capability-manager.vala"
		_tmp9_ = _tmp8_;
#line 187 "../src/capability-manager.vala"
		_tmp10_ = pomodoro_capability_get_group (capability);
#line 187 "../src/capability-manager.vala"
		_tmp11_ = _tmp10_;
#line 187 "../src/capability-manager.vala"
		if (pomodoro_capability_manager_get_group_priority (_tmp9_) < pomodoro_capability_manager_get_group_priority (_tmp11_)) {
#line 868 "capability-manager.c"
			GHashTable* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			PomodoroCapability* _tmp16_;
#line 190 "../src/capability-manager.vala"
			_tmp12_ = self->priv->capabilities;
#line 190 "../src/capability-manager.vala"
			_tmp13_ = pomodoro_capability_get_name (capability);
#line 190 "../src/capability-manager.vala"
			_tmp14_ = _tmp13_;
#line 190 "../src/capability-manager.vala"
			_tmp15_ = g_strdup (_tmp14_);
#line 190 "../src/capability-manager.vala"
			_tmp16_ = _g_object_ref0 (capability);
#line 190 "../src/capability-manager.vala"
			g_hash_table_replace (_tmp12_, _tmp15_, _tmp16_);
#line 886 "capability-manager.c"
		}
	} else {
		GHashTable* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		PomodoroCapability* _tmp21_;
#line 194 "../src/capability-manager.vala"
		_tmp17_ = self->priv->capabilities;
#line 194 "../src/capability-manager.vala"
		_tmp18_ = pomodoro_capability_get_name (capability);
#line 194 "../src/capability-manager.vala"
		_tmp19_ = _tmp18_;
#line 194 "../src/capability-manager.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 194 "../src/capability-manager.vala"
		_tmp21_ = _g_object_ref0 (capability);
#line 194 "../src/capability-manager.vala"
		g_hash_table_insert (_tmp17_, _tmp20_, _tmp21_);
#line 906 "capability-manager.c"
	}
#line 197 "../src/capability-manager.vala"
	_tmp22_ = self->priv->enabled_capabilities;
#line 197 "../src/capability-manager.vala"
	_tmp23_ = pomodoro_capability_get_name (capability);
#line 197 "../src/capability-manager.vala"
	_tmp24_ = _tmp23_;
#line 197 "../src/capability-manager.vala"
	if (g_hash_table_contains (_tmp22_, _tmp24_)) {
#line 916 "capability-manager.c"
		gboolean _tmp25_;
		gboolean _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
#line 198 "../src/capability-manager.vala"
		_tmp25_ = pomodoro_capability_get_enabled (capability);
#line 198 "../src/capability-manager.vala"
		_tmp26_ = _tmp25_;
#line 198 "../src/capability-manager.vala"
		if (!_tmp26_) {
#line 199 "../src/capability-manager.vala"
			g_signal_emit_by_name (capability, "enable");
#line 929 "capability-manager.c"
		}
#line 202 "../src/capability-manager.vala"
		_tmp27_ = pomodoro_capability_get_name (capability);
#line 202 "../src/capability-manager.vala"
		_tmp28_ = _tmp27_;
#line 202 "../src/capability-manager.vala"
		g_signal_emit (self, pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_CAPABILITY_ENABLED_SIGNAL], 0, _tmp28_);
#line 937 "capability-manager.c"
	} else {
		gboolean _tmp29_;
		gboolean _tmp30_;
#line 205 "../src/capability-manager.vala"
		_tmp29_ = pomodoro_capability_get_enabled (capability);
#line 205 "../src/capability-manager.vala"
		_tmp30_ = _tmp29_;
#line 205 "../src/capability-manager.vala"
		if (_tmp30_) {
#line 206 "../src/capability-manager.vala"
			g_signal_emit_by_name (capability, "disable");
#line 949 "capability-manager.c"
		}
	}
#line 180 "../src/capability-manager.vala"
	_g_object_unref0 (preferred_capability);
#line 954 "capability-manager.c"
}

static void
pomodoro_capability_manager_remove_capability_internal (PomodoroCapabilityManager* self,
                                                        PomodoroCapability* capability)
{
	PomodoroCapability* preferred_capability = NULL;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gconstpointer _tmp3_;
	PomodoroCapability* _tmp4_;
	PomodoroCapability* _tmp5_;
#line 211 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 213 "../src/capability-manager.vala"
	_tmp0_ = self->priv->capabilities;
#line 213 "../src/capability-manager.vala"
	_tmp1_ = pomodoro_capability_get_name (capability);
#line 213 "../src/capability-manager.vala"
	_tmp2_ = _tmp1_;
#line 213 "../src/capability-manager.vala"
	_tmp3_ = g_hash_table_lookup (_tmp0_, _tmp2_);
#line 213 "../src/capability-manager.vala"
	_tmp4_ = _g_object_ref0 ((PomodoroCapability*) _tmp3_);
#line 213 "../src/capability-manager.vala"
	preferred_capability = _tmp4_;
#line 215 "../src/capability-manager.vala"
	_tmp5_ = preferred_capability;
#line 215 "../src/capability-manager.vala"
	if (_tmp5_ == capability) {
#line 988 "capability-manager.c"
		GHashTable* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GSList* iter = NULL;
		GSList* _tmp9_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 217 "../src/capability-manager.vala"
		_tmp6_ = self->priv->capabilities;
#line 217 "../src/capability-manager.vala"
		_tmp7_ = pomodoro_capability_get_name (capability);
#line 217 "../src/capability-manager.vala"
		_tmp8_ = _tmp7_;
#line 217 "../src/capability-manager.vala"
		g_hash_table_remove (_tmp6_, _tmp8_);
#line 219 "../src/capability-manager.vala"
		g_signal_emit_by_name (capability, "disable");
#line 223 "../src/capability-manager.vala"
		_tmp9_ = self->priv->groups;
#line 223 "../src/capability-manager.vala"
		iter = _tmp9_;
#line 225 "../src/capability-manager.vala"
		while (TRUE) {
#line 1012 "capability-manager.c"
			GSList* _tmp10_;
			GSList* _tmp11_;
			gconstpointer _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			PomodoroCapability* _tmp15_;
			PomodoroCapability* _tmp16_;
			PomodoroCapability* _tmp17_;
			GSList* _tmp19_;
			GSList* _tmp20_;
#line 225 "../src/capability-manager.vala"
			_tmp10_ = iter;
#line 225 "../src/capability-manager.vala"
			if (!(_tmp10_ != NULL)) {
#line 225 "../src/capability-manager.vala"
				break;
#line 1029 "capability-manager.c"
			}
#line 227 "../src/capability-manager.vala"
			_tmp11_ = iter;
#line 227 "../src/capability-manager.vala"
			_tmp12_ = _tmp11_->data;
#line 227 "../src/capability-manager.vala"
			_tmp13_ = pomodoro_capability_get_name (capability);
#line 227 "../src/capability-manager.vala"
			_tmp14_ = _tmp13_;
#line 227 "../src/capability-manager.vala"
			_tmp15_ = pomodoro_capability_group_lookup ((PomodoroCapabilityGroup*) _tmp12_, _tmp14_);
#line 227 "../src/capability-manager.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 227 "../src/capability-manager.vala"
			_g_object_unref0 (preferred_capability);
#line 227 "../src/capability-manager.vala"
			preferred_capability = _tmp16_;
#line 229 "../src/capability-manager.vala"
			_tmp17_ = preferred_capability;
#line 229 "../src/capability-manager.vala"
			if (_tmp17_ != NULL) {
#line 1051 "capability-manager.c"
				PomodoroCapability* _tmp18_;
#line 230 "../src/capability-manager.vala"
				_tmp18_ = preferred_capability;
#line 230 "../src/capability-manager.vala"
				pomodoro_capability_manager_add_capability_internal (self, _tmp18_);
#line 231 "../src/capability-manager.vala"
				break;
#line 1059 "capability-manager.c"
			}
#line 234 "../src/capability-manager.vala"
			_tmp19_ = iter;
#line 234 "../src/capability-manager.vala"
			_tmp20_ = _tmp19_->next;
#line 234 "../src/capability-manager.vala"
			iter = _tmp20_;
#line 1067 "capability-manager.c"
		}
#line 237 "../src/capability-manager.vala"
		_tmp21_ = pomodoro_capability_get_name (capability);
#line 237 "../src/capability-manager.vala"
		_tmp22_ = _tmp21_;
#line 237 "../src/capability-manager.vala"
		g_signal_emit (self, pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_CAPABILITY_DISABLED_SIGNAL], 0, _tmp22_);
#line 1075 "capability-manager.c"
	}
#line 211 "../src/capability-manager.vala"
	_g_object_unref0 (preferred_capability);
#line 1079 "capability-manager.c"
}

static void
pomodoro_capability_manager_on_group_capability_added (PomodoroCapabilityManager* self,
                                                       PomodoroCapabilityGroup* group,
                                                       PomodoroCapability* capability)
{
#line 241 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/capability-manager.vala"
	g_return_if_fail (group != NULL);
#line 241 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 244 "../src/capability-manager.vala"
	pomodoro_capability_manager_add_capability_internal (self, capability);
#line 1095 "capability-manager.c"
}

static void
pomodoro_capability_manager_on_group_capability_removed (PomodoroCapabilityManager* self,
                                                         PomodoroCapabilityGroup* group,
                                                         PomodoroCapability* capability)
{
#line 247 "../src/capability-manager.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/capability-manager.vala"
	g_return_if_fail (group != NULL);
#line 247 "../src/capability-manager.vala"
	g_return_if_fail (capability != NULL);
#line 250 "../src/capability-manager.vala"
	pomodoro_capability_manager_remove_capability_internal (self, capability);
#line 1111 "capability-manager.c"
}

static void
pomodoro_capability_manager_real_dispose (GObject* base)
{
	PomodoroCapabilityManager * self;
#line 253 "../src/capability-manager.vala"
	self = (PomodoroCapabilityManager*) base;
#line 255 "../src/capability-manager.vala"
	pomodoro_capability_manager_disable_all (self);
#line 257 "../src/capability-manager.vala"
	G_OBJECT_CLASS (pomodoro_capability_manager_parent_class)->dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 1124 "capability-manager.c"
}

PomodoroCapabilityManager*
pomodoro_capability_manager_construct (GType object_type)
{
	PomodoroCapabilityManager * self = NULL;
#line 33 "../src/capability-manager.vala"
	self = (PomodoroCapabilityManager*) g_object_new (object_type, NULL);
#line 33 "../src/capability-manager.vala"
	return self;
#line 1135 "capability-manager.c"
}

PomodoroCapabilityManager*
pomodoro_capability_manager_new (void)
{
#line 33 "../src/capability-manager.vala"
	return pomodoro_capability_manager_construct (POMODORO_TYPE_CAPABILITY_MANAGER);
#line 1143 "capability-manager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 42 "../src/capability-manager.vala"
	var = (g_free (var), NULL);
#line 1151 "capability-manager.c"
}

static GObject *
pomodoro_capability_manager_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroCapabilityManager * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
#line 39 "../src/capability-manager.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_capability_manager_parent_class);
#line 39 "../src/capability-manager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/capability-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_MANAGER, PomodoroCapabilityManager);
#line 42 "../src/capability-manager.vala"
	_tmp0_ = g_str_hash;
#line 42 "../src/capability-manager.vala"
	_tmp1_ = g_str_equal;
#line 42 "../src/capability-manager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 42 "../src/capability-manager.vala"
	_g_hash_table_unref0 (self->priv->capabilities);
#line 42 "../src/capability-manager.vala"
	self->priv->capabilities = _tmp2_;
#line 45 "../src/capability-manager.vala"
	_tmp3_ = g_str_hash;
#line 45 "../src/capability-manager.vala"
	_tmp4_ = g_str_equal;
#line 45 "../src/capability-manager.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, NULL, _g_free0_);
#line 45 "../src/capability-manager.vala"
	_g_hash_table_unref0 (self->priv->enabled_capabilities);
#line 45 "../src/capability-manager.vala"
	self->priv->enabled_capabilities = _tmp5_;
#line 48 "../src/capability-manager.vala"
	(self->priv->groups == NULL) ? NULL : (self->priv->groups = (_g_slist_free__g_object_unref0_ (self->priv->groups), NULL));
#line 48 "../src/capability-manager.vala"
	self->priv->groups = NULL;
#line 39 "../src/capability-manager.vala"
	return obj;
#line 1200 "capability-manager.c"
}

static void
pomodoro_capability_manager_class_init (PomodoroCapabilityManagerClass * klass,
                                        gpointer klass_data)
{
#line 33 "../src/capability-manager.vala"
	pomodoro_capability_manager_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/capability-manager.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroCapabilityManager_private_offset);
#line 33 "../src/capability-manager.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) pomodoro_capability_manager_real_dispose;
#line 33 "../src/capability-manager.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_capability_manager_constructor;
#line 33 "../src/capability-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_capability_manager_finalize;
#line 33 "../src/capability-manager.vala"
	pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_GROUP_ADDED_SIGNAL] = g_signal_new ("group-added", POMODORO_TYPE_CAPABILITY_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY_GROUP);
#line 33 "../src/capability-manager.vala"
	pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_GROUP_REMOVED_SIGNAL] = g_signal_new ("group-removed", POMODORO_TYPE_CAPABILITY_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, POMODORO_TYPE_CAPABILITY_GROUP);
#line 33 "../src/capability-manager.vala"
	pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_CAPABILITY_ENABLED_SIGNAL] = g_signal_new ("capability-enabled", POMODORO_TYPE_CAPABILITY_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 33 "../src/capability-manager.vala"
	pomodoro_capability_manager_signals[POMODORO_CAPABILITY_MANAGER_CAPABILITY_DISABLED_SIGNAL] = g_signal_new ("capability-disabled", POMODORO_TYPE_CAPABILITY_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 1225 "capability-manager.c"
}

static void
pomodoro_capability_manager_instance_init (PomodoroCapabilityManager * self,
                                           gpointer klass)
{
#line 33 "../src/capability-manager.vala"
	self->priv = pomodoro_capability_manager_get_instance_private (self);
#line 1234 "capability-manager.c"
}

static void
pomodoro_capability_manager_finalize (GObject * obj)
{
	PomodoroCapabilityManager * self;
#line 33 "../src/capability-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_CAPABILITY_MANAGER, PomodoroCapabilityManager);
#line 35 "../src/capability-manager.vala"
	_g_hash_table_unref0 (self->priv->capabilities);
#line 36 "../src/capability-manager.vala"
	_g_hash_table_unref0 (self->priv->enabled_capabilities);
#line 37 "../src/capability-manager.vala"
	(self->priv->groups == NULL) ? NULL : (self->priv->groups = (_g_slist_free__g_object_unref0_ (self->priv->groups), NULL));
#line 33 "../src/capability-manager.vala"
	G_OBJECT_CLASS (pomodoro_capability_manager_parent_class)->finalize (obj);
#line 1251 "capability-manager.c"
}

static GType
pomodoro_capability_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroCapabilityManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_capability_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroCapabilityManager), 0, (GInstanceInitFunc) pomodoro_capability_manager_instance_init, NULL };
	GType pomodoro_capability_manager_type_id;
	pomodoro_capability_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PomodoroCapabilityManager", &g_define_type_info, 0);
	PomodoroCapabilityManager_private_offset = g_type_add_instance_private (pomodoro_capability_manager_type_id, sizeof (PomodoroCapabilityManagerPrivate));
	return pomodoro_capability_manager_type_id;
}

GType
pomodoro_capability_manager_get_type (void)
{
	static volatile gsize pomodoro_capability_manager_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_capability_manager_type_id__once)) {
		GType pomodoro_capability_manager_type_id;
		pomodoro_capability_manager_type_id = pomodoro_capability_manager_get_type_once ();
		g_once_init_leave (&pomodoro_capability_manager_type_id__once, pomodoro_capability_manager_type_id);
	}
	return pomodoro_capability_manager_type_id__once;
}

